package com.jmeeting.sever;

import java.awt.AWTException;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.Toolkit;
import java.awt.image.BufferedImage;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import javax.imageio.ImageIO;

/**
* @author LanXJ @doctime 2010-7-8
* 开启一个设定端口的服务，该服务用于向客户端传送主机的屏幕信息，实现客户端对服务器端主机的监控
* 实例化线程类后默认打开DEFAULT_SERVER_PORT=30011 端口实现监听
* 可以通过changeServerPort改变监听端口，也可以通过getServerPort来查询当前监听端口
*/
public class SendScreenImg implements Runnable{

public static final int DEFAULT_SERVER_PORT=30011;
private int serverPort;
private Robot robot;
private ServerSocket serverSocket;
private Rectangle rect;
private Dimension screen;
private BufferedImage img;
private Socket socket;
private ZipOutputStream zip;

public SendScreenImg() {
   this.serverPort=SendScreenImg.DEFAULT_SERVER_PORT;

   try {
    serverSocket = new ServerSocket(this.serverPort);
    serverSocket.setSoTimeout(86400000);
   } catch (IOException e1) {
    e1.printStackTrace();
   }

   try {
    robot = new Robot();
   } catch (AWTException e) {
    e.printStackTrace();
   }
   screen = Toolkit.getDefaultToolkit().getScreenSize();
   rect = new Rectangle(screen);

}
public void changeServerPort(int serverPort){
   if(this.serverPort==serverPort)return;
   this.serverPort=serverPort;
   try {
    this.serverSocket.close();
   } catch (Exception e) {}
   try {
    serverSocket = new ServerSocket(this.serverPort);
    serverSocket.setSoTimeout(86400000);
   } catch (IOException e1) {
    e1.printStackTrace();
   }
}
public int getServerPort(){
   return this.serverPort;
}

public void run() {
   while (true) {
             try {
            System.out.println("等待接收截屏信息");
                 socket = serverSocket.accept();
                 zip = new ZipOutputStream(new DataOutputStream(socket.getOutputStream()));
                 zip.setLevel(9);//为后续的 DEFLATED 条目设置压缩级别 压缩级别 (0-9)
                 try {
                img = robot.createScreenCapture(rect);
                     zip.putNextEntry(new ZipEntry("test.jpg"));
                     ImageIO.write(img, "jpg", zip);
                     if(zip!=null)zip.close();
                     System.out.println("被控端：connect");
                 } catch (IOException ioe) {
                     System.out.println("被控端：disconnect");
                 }
             } catch (IOException ioe) {
            System.out.println("错误1");
             } finally {
                 if (socket != null) {
                     try {
                         socket.close();
                     } catch (IOException e) {
                     }
                 }
             }
         }
}
}